#include <cstdlib>
#include <iostream>
#include <fstream>
#include <string>
#include <iomanip>

#include <algorithm>
#include <vector>
#include <set>
#include <map>

#include "net.h"
#include "route_table.h"

using namespace std;

int main(int argc, char **argv) {
    string line;
    route_table rt;

    if (argc < 2) {
	cerr << "Usage: collapse_route file" << endl;
	exit(20);
    }

    ifstream inp(argv[1]);
    while ( getline(inp, line, '\n')) {
	Net dest_net(line);
	Host next_hop(line.substr(line.find(' ')));

	rt.insert(dest_net, next_hop);
    }

    rt.collapse();
    cout << rt;
}
